<?php

$TEST = TRUE;

clearstatcache();

/* -------------------------------------------------------------------------------- FILE DA INVIARE */

$nomeFileAllegato = "2019_LUONGO_spesesanitarie_19_1";  // file da trattare nel processo di lavorazione (.txt) SENZA estensione


/* -------------------------------------------------------------------------------- parametri per RICEVUTE DI ATTESTAZIONE DEGLI INVII */

$protocollo = "20012114040801305";

if( !empty( $_SESSION['protocollo'] ) ) $protocollo = $_SESSION['protocollo'];

if( !empty( $_REQUEST['protocollo'] ) ) $protocollo = $_REQUEST['protocollo'];

if( !empty( $argv[1] ) ) $protocollo = $argv[1];


/* -------------------------------------------------------------------------------- parametri per ESITO DOPO IL TRASFERIMENTO DELLE FATTURE */

$ric_dataInizio     = ""; // "01-09-2019";
$ric_dataFine       = ""; // "30-09-2019";


/* -------------------------------------------------------------------------------- parametri per INTERROGAZIONE PUNTUALE DEI DOCUMENTI */

$ric_dataEmissione  = "2019-11-02"; // "2019-09-01";
$ric_dispositivo    = "1";          // "12";
$ric_numDocumento   = "63";         // "1";


/* -------------------------------------------------------------------------------- parametri per REPORT MENSILE DEI DOCUMENTI INVIATI */

$ric_tipoEstrazione = "I";
$ric_annoMese       = "201911";


/* -------------------------------------------------------------------------------- altri parametri */

$PercorsoDocRicevuti = "730_2019_RisultatiInvio/";  // percorso dove depositare i documenti ricevuti

if (!is_dir($PercorsoDocRicevuti)) mkdir($PercorsoDocRicevuti, 0777);


$fileLog = "__TesseraSanitaria.log";  // dettaglio dei passi della lavorazione (log da conservare come ulteriore prova)

$fp=fopen("FC/_sanitelCF.cer", "r"); $pub_key=fread($fp,8192); fclose($fp); $key_resource = openssl_get_publickey($pub_key);


/* -------------------------------------------------------------------------------- impostazioni base PHP */

ini_set('error_reporting', E_ALL | E_STRICT);
ini_set('display_errors', FALSE);
ini_set('log_errors', TRUE);
ini_set('error_log', $fileLog);

error_log(".", 0);
error_log("Current PHP version     : ".phpversion(), 0);
error_log("main                    : ".$_SERVER['PHP_SELF'], 0);


/* -------------------------------------------------------------------------------- parametri dei soggetti */

if( $TEST )
{
    error_log("TEST RUN ****************", 0);

    $name                   = "TEST INTERMEDIARIO, COMMERCIALISTA";
    $user                   = "MSSSMN78C13C773M";
    $psw                    = "sotcat00";
    $networkUser            = "";
    $networkPsw             = "";
    $cfProprietario         = "FBNFBA62S28H501F";
    $cfProprietarioCifrato  = EncryptData($cfProprietario);
//  $cfProprietarioCifrato  = "qUaGLjq9XGinTtpu8kRWKzE0Oz4MgCFD1QXELf71/AXzY8XvVD16SpzQqMxfbtVe0GvRUuT4qLEiVZt70uYD368dUvQK1G3Tc/JC6D33HZ1hW+ZdI5dkPCXu5IHHKUkSq263qZovE+JLbMyuROMCcu4RbWfIqKzbHT/iqiPF/ho=";
    $piProprietario         = "00265910661";
    $pincodeInviante        = "4B64AA1D";
    $pincodeInvianteCifrato = "4B64AA1D";
//  $pincodeInvianteCifrato = EncryptData($pincodeInviante);
//  $pincodeInvianteCifrato = "uellegTqPXuEdAUDhv+enDLt1z8BMYRIfCo8bMoPZgbThjmYh2y9ZuUYKR1byHwizXs5bNSon/bGLfVaJG8xCoNrvxO4XoxpxNDr/zZJxOftr5PdoJfi3tib4XDt2in7LZg1ZntykUbURRxzUBNobEiGXwEWJXiNQD5nXQvsX3s=";
    $codiceRegione          = "";
    $codiceAsl              = "";
    $codiceSSA              = "";
    $opzionale1             = "07874631000-000";  // codice Sede
    $opzionale2             = "0";
    $opzionale3             = "0";

    $InvioTelematico        = "https://invioSS730pTest.sanita.finanze.it/entrate/InvioTelematicoSS730pMtomWeb/InvioTelematicoSS730pMtomPort"; 
    $ricevutePdf            = "https://invioSS730pTest.sanita.finanze.it/entrate/Ricevute730ServiceWeb/ricevutePdf";
}
else
{
    error_log("INVIO EFFETTIVO *********", 0);

    // INSERIRE QUI I DATI EFFETTIVI

}

define ("_InvioTelematico_WSDL"        ,"InvioTelematicoSpeseSanitarie730p.wsdl"); 
define ("_DettaglioErrori_WSDL"        ,"DettaglioErrori730Service.wsdl");
define ("_EsitoInvio_WSDL"             ,"EsitoInvioDatiSpesa730Service.wsdl");
define ("_ricevutePdf_WSDL"            ,"RicevutaPdf730Service.wsdl");
define ("_InterrogazionePuntuale_WSDL" ,"InterrogazionePuntuale730Service.wsdl");
define ("_ReportMensile_WSDL"          ,"ReportMensile730Service.wsdl");


/* -------------------------------------------------------------------------------- preparazione dati SOAP client */

if ( !empty($psw) )
{
    $login    = $user;
    $password = $psw;
}
else
{
    $login    = $networkUser;
    $password = $networkPsw;
}

$SoapClientParam = array
(
    "useMTOM"        => TRUE,
    "location"       => "x", 
    "login"          => $login, 
    "password"       => $password, 
    "authentication" => SOAP_AUTHENTICATION_BASIC,
    "keep_alive"     => TRUE,
    "cache_wsdl"     => WSDL_CACHE_NONE,
    "trace"          => TRUE, 
    "exceptions"     => TRUE,
    "stream_context" => stream_context_create(array
    (
        "ssl" => array
        (
            "verify_peer"          => FALSE,
            "verify_peer_name"     => FALSE,
            "capture_session_meta" => TRUE,
        ),
    )),
);


/* -------------------------------------------------------------------------------- log values */

error_log("name                    : ".$name, 0);
error_log("login                   : ".$login, 0);
error_log("password                : ".$password, 0);
error_log("codiceRegione           : ".$codiceRegione, 0);
error_log("codiceAsl               : ".$codiceAsl, 0);
error_log("codiceSSA               : ".$codiceSSA, 0);
error_log("cfProprietario          : ".$cfProprietario, 0);
error_log("cfProprietarioCifrato   : ".$cfProprietarioCifrato, 0);
error_log("piProprietario          : ".$piProprietario, 0);
error_log("pincodeInviante         : ".$pincodeInviante, 0);
error_log("pincodeInvianteCifrato  : ".$pincodeInvianteCifrato, 0);
error_log("opzionale1              : ".$opzionale1, 0);
error_log("opzionale2              : ".$opzionale2, 0);
error_log("opzionale3              : ".$opzionale3, 0);

/* -------------------------------------------------------------------------------- utilità NON TOCCARE */

function envelopes()
{
    global $client;

    echo "REQUEST HEADERS ============" . "<br />";
    $LastRequestHeaders = $client->__getLastRequestHeaders();
    echo "<xmp>"; var_dump($LastRequestHeaders); echo "</xmp><br /><br />";

    echo "REQUEST ====================" . "<br />";
    $LastRequest = $client->__getLastRequest();
    echo "<xmp>"; var_dump($LastRequest); echo "</xmp><br /><br />";

    echo "RESPONSE HEADERS ===========" . "<br />";
    $LastResponseHeaders = $client->__getLastResponseHeaders();
    echo "<xmp>"; var_dump($LastResponseHeaders); echo "</xmp><br /><br />";

    echo "RESPONSE ===================" . "<br />";
    $LastResponse = $client->__getLastResponse();
    echo "<xmp>"; var_dump($LastResponse); echo "</xmp><br /><br />";
}

function EncryptData($source)
{
    global $key_resource;

//  $crypted_text = file_get_contents( "FC/x_".$source.".enc", FILE_USE_INCLUDE_PATH );

    openssl_public_encrypt($source, $crypted_text, $key_resource);
    return(base64_encode($crypted_text));
}

function ReportOutput($var)
{
    global $response;
    if ( !empty($response->{$var}) )
    {
        error_log($var." = ".$response->{$var}, 0);
        echo $var." = ".$response->{$var}."<br />";
    }
}

function LogTitles($string=null, $addtext=null)
{
    echo "<h4>".$string."</h4>".$addtext;
    error_log($string, 0);
}

require_once 'myUtils/show_vars.php';
?>
